#include <windows.h>
#include <CommCtrl.h>
#include <stdio.h> 
#include <string.h> 
#include <tchar.h>

#pragma comment(lib, "comctl32.lib")

#define IDC_BUTTON_RELOAD 111
#define IDC_LIST_BOX      112
#define IDC_STATUSBAR     113

#define IDM_NOWY    101
#define IDM_ZAMKNIJ 102
#define IDM_SAVE  105

#define MAX_LINE 500
TCHAR napis[MAX_LINE];

BOOL CALLBACK EnumWindowsProc(HWND   hwnd, LPARAM lParam)
{
	int n = 0;
	n = GetWindowTextLength(hwnd);
	if (n > 0)
	{
		GetWindowText(hwnd, napis, MAX_LINE);
		SendMessage(lParam, LB_ADDSTRING, 0, napis);
	}
	return TRUE;
}


LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static HWND hListBox;
	static HMENU hMenu, hSubMenu;

	switch (msg)
	{
	case WM_CREATE:
		CreateWindow(TEXT("BUTTON"), TEXT("Odwie"), WS_CHILD | WS_VISIBLE,
			0, 0, 0, 0, hwnd, (HMENU)IDC_BUTTON_RELOAD, GetModuleHandle(NULL), NULL);

		hListBox = CreateWindow(WC_LISTBOX, NULL, WS_CHILD | WS_VISIBLE | WS_BORDER | LBS_STANDARD,
			0, 0, 0, 0, hwnd, (HMENU)IDC_LIST_BOX, GetModuleHandle(NULL), NULL);
		CreateWindow(STATUSCLASSNAME, NULL, WS_CHILD | WS_VISIBLE | SBARS_SIZEGRIP,
			0, 0, 0, 0, hwnd, (HMENU)IDC_STATUSBAR, GetModuleHandle(NULL), NULL);

		SendMessage(GetDlgItem(hwnd, IDC_STATUSBAR), SB_SETTEXT, 0, (LPARAM)TEXT("Naciniej przycisk"));

		hMenu = CreateMenu();
		hSubMenu = CreateMenu();
		AppendMenu(hSubMenu, MF_STRING, IDM_NOWY, TEXT("&Nowy"));
		AppendMenu(hSubMenu, MF_STRING, IDC_BUTTON_RELOAD, TEXT("&Odwie"));
		AppendMenu(hSubMenu, MF_STRING, IDM_SAVE, TEXT("&Zapisz"));
		AppendMenu(hSubMenu, MF_SEPARATOR, 0, NULL);
		AppendMenu(hSubMenu, MF_STRING, IDM_ZAMKNIJ, TEXT("&Zamknij"));
		AppendMenu(hMenu, MF_POPUP, (UINT_PTR)hSubMenu, TEXT("&Plik"));

		SetMenu(hwnd, hMenu);

		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		
		  case IDC_BUTTON_RELOAD:
		  {
			  int count = 0;
			  TCHAR buf[100];
			  SendMessage(hListBox, LB_RESETCONTENT, 0, 0);
			  EnumWindows(EnumWindowsProc, (LPARAM)hListBox);
			  count = SendMessage(GetDlgItem(hwnd, IDC_LIST_BOX), LB_GETCOUNT, 0, 0);
			  _sntprintf(buf, 100, TEXT("Liczba okien: %d"), count);
			  SendMessage(GetDlgItem(hwnd, IDC_STATUSBAR), SB_SETTEXT, 0, (LPARAM)buf);

			  ShowWindow(GetDlgItem(hwnd, IDC_STATUSBAR), SW_SHOW);
			  break;
		  }
		  case IDM_ZAMKNIJ:	SendMessage(hwnd, WM_CLOSE, 0, 0); break;
		  case IDM_NOWY:	SendMessage(hListBox, LB_RESETCONTENT, 0, 0); break;
		}
		break;

	case WM_SIZE:
	{
		RECT clientRect, statusRect;
		LONG button_height = 40, listBox_height = 0, statusHeight = 0;
		GetClientRect(hwnd, &clientRect);
		SendMessage(GetDlgItem(hwnd, IDC_STATUSBAR), WM_SIZE, 0, 0);
		GetWindowRect(GetDlgItem(hwnd, IDC_STATUSBAR), &statusRect);
		statusHeight = statusRect.bottom - statusRect.top;
		listBox_height = clientRect.bottom - button_height - statusHeight;
		SetWindowPos(GetDlgItem(hwnd, IDC_BUTTON_RELOAD), NULL, 0, 0 , clientRect.right, button_height, SWP_NOZORDER);
		SetWindowPos(GetDlgItem(hwnd, IDC_LIST_BOX), NULL, 0, button_height, clientRect.right, listBox_height, SWP_NOZORDER);
		break;
	}


	case WM_RBUTTONDOWN:
	{
		SetForegroundWindow(hwnd);
		POINT point;
		GetCursorPos(&point);
		TrackPopupMenu(hSubMenu, TPM_BOTTOMALIGN | TPM_LEFTALIGN, point.x, point.y, 0, hwnd, NULL);
	}
	break;
	case WM_CLOSE:
		DestroyWindow(hwnd);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hwnd, msg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASSEX wndClass;
	HWND hwnd;
	MSG Msg;
	TCHAR title[100];

	
	InitCommonControls();

	ZeroMemory(&wndClass, sizeof(wndClass));
	wndClass.cbSize = sizeof(wndClass);
	wndClass.lpszClassName = TEXT("Klasa okien");
	wndClass.hInstance = hInstance;
	wndClass.lpfnWndProc = WndProc;
	wndClass.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndClass.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
	wndClass.lpszMenuName = NULL; 

	
	if (!RegisterClassEx(&wndClass))
	{
		MessageBox(NULL, TEXT("Blad rejestrowania klasy okna"), TEXT("Blad"),
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}

	
	hwnd = CreateWindow(TEXT("Klasa okien"), TEXT("Lista okien"), WS_OVERLAPPEDWINDOW, 10, 10, 500, 600,
		NULL, NULL, hInstance, NULL);

	if (hwnd == NULL)
	{
		MessageBox(NULL, TEXT("Blad tworzenia okna!"), TEXT("Blad"),
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}

	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);

	while (GetMessage(&Msg, NULL, 0, 0) > 0)
	{
		TranslateMessage(&Msg);
		DispatchMessage(&Msg);
	}

	return Msg.wParam;
}
